/*
  Made by Cicely 2021
  This program will test the three RGB LEDs at once
*/
#include <SoftwareSerial.h>
#define BUTTON 4
#define LED_BLUE 8
#define LED_GREEN 6
#define LED_RED 7
#define LEDA 10
#define LEDB 9
#define LEDC 0
#define LEDD 1
#define LEDE 2
#define LEDF 3
#define MISO 5

int button_pressed = 0;

SoftwareSerial BTserial (MISO, MISO);
char BTcolor = 0;                //Variable for storing color
char BTnumber = 0;               //Variable for storing hue

int lastRed = 0;
int lastGreen = 0;
int lastBlue = 0;

void checkButton() {
  // Adds 1 to the counter each time the button is pressed
  if (digitalRead(BUTTON)) {
    button_pressed = button_pressed + digitalRead(BUTTON);
    delay(200);
  }
}

void delayIfNotPressed(int delSpeed2) {
  if (digitalRead(BUTTON)) {
    return;
  } else {
    delay(delSpeed2);
  }
}

void leftToRight(int delSpeed) {
  digitalWrite(LEDA, HIGH); // flash each led quickly
  delayIfNotPressed(delSpeed);
  digitalWrite(LEDA, LOW);

  digitalWrite(LEDB, HIGH);
  delayIfNotPressed(delSpeed);
  digitalWrite(LEDB, LOW);

  digitalWrite(LEDC, HIGH);
  delayIfNotPressed(delSpeed);
  digitalWrite(LEDC, LOW);

  digitalWrite(LEDD, HIGH);
  delayIfNotPressed(delSpeed);
  digitalWrite(LEDD, LOW);

  digitalWrite(LEDE, HIGH);
  delayIfNotPressed(delSpeed);
  digitalWrite(LEDE, LOW);

  digitalWrite(LEDF, HIGH);
  delayIfNotPressed(delSpeed);
  digitalWrite(LEDF, LOW);
}

void middleOut(int delSpeed) {
  digitalWrite(LEDA, HIGH); // flash each led quickly
  digitalWrite(LEDF, HIGH);
  delayIfNotPressed(delSpeed);
  digitalWrite(LEDA, LOW);
  digitalWrite(LEDF, LOW);

  digitalWrite(LEDB, HIGH);
  digitalWrite(LEDE, HIGH);
  delayIfNotPressed(delSpeed);
  digitalWrite(LEDB, LOW);
  digitalWrite(LEDE, LOW);

  digitalWrite(LEDC, HIGH);
  digitalWrite(LEDD, HIGH);
  delayIfNotPressed(delSpeed);
  digitalWrite(LEDC, LOW);
  digitalWrite(LEDD, LOW);

}

void setRGB (int red, int green, int blue) {
  analogWrite(LED_RED, 255 - red);
  analogWrite(LED_GREEN, 255 - green);
  analogWrite(LED_BLUE, 255 - blue);
}

void sweep(int delSpeed) {
  digitalWrite(LEDA, HIGH); // flash each led quickly
  digitalWrite(LEDF, HIGH);
  delayIfNotPressed(delSpeed);
  digitalWrite(LEDA, LOW);
  digitalWrite(LEDF, LOW);

  digitalWrite(LEDB, HIGH);
  digitalWrite(LEDE, HIGH);
  delayIfNotPressed(delSpeed);
  digitalWrite(LEDB, LOW);
  digitalWrite(LEDE, LOW);

  digitalWrite(LEDC, HIGH);
  digitalWrite(LEDD, HIGH);
  delayIfNotPressed(delSpeed);
  digitalWrite(LEDC, LOW);
  digitalWrite(LEDD, LOW);

  digitalWrite(LEDB, HIGH);
  digitalWrite(LEDE, HIGH);
  delayIfNotPressed(delSpeed);
  digitalWrite(LEDB, LOW);
  digitalWrite(LEDE, LOW);
}

void alwaysOn() {
  digitalWrite(LEDB, HIGH);
  digitalWrite(LEDE, HIGH);

}

// the setup function runs once when you press reset or power the board
void setup() {
  pinMode(BUTTON, OUTPUT);  // Technically the button is an input, but because it kept triggering itself we've configured it to sink current so it doesn't accidentally trigger
  pinMode(LED_BLUE, INPUT_PULLUP);
  pinMode(LED_GREEN, INPUT_PULLUP);
  pinMode(LED_RED, INPUT_PULLUP);
  pinMode(LEDA, OUTPUT);
  pinMode(LEDB, OUTPUT);
  pinMode(LEDC, OUTPUT);
  pinMode(LEDD, OUTPUT);
  pinMode(LEDE, OUTPUT);
  pinMode(LEDF, OUTPUT);

  BTserial.begin(9600);

  digitalWrite(LED_RED, HIGH);//LED outputs are inverted!!!!!
  digitalWrite(LED_GREEN, HIGH);//that means high is off and low is on!!!! :(
  digitalWrite(LED_BLUE, HIGH);
  digitalWrite(LEDA, LOW);
  digitalWrite(LEDB, LOW);
  digitalWrite(LEDC, LOW);
  digitalWrite(LEDD, LOW);
  digitalWrite(LEDE, LOW);
  digitalWrite(LEDF, LOW);
}

// the loop function runs over and over again forever
void loop() {

  if (BTserial.available()) {
    delay(10);
    BTcolor = BTserial.read();      //Read the incoming data and store it into variable
    BTnumber = BTserial.parseInt();
  }
  if (BTcolor == 'R') {
    lastRed = BTnumber;
    setRGB (lastRed, lastGreen, lastBlue);
  }
  if (BTcolor == 'G') {
    lastGreen = BTnumber;
    setRGB (lastRed, lastGreen, lastBlue);
  }
  if (BTcolor == 'B') {
    lastBlue = BTnumber;
    setRGB (lastRed, lastGreen, lastBlue);
  }
  if (BTcolor == 'W') { //this is a shortcut for reading mode
    setRGB (BTnumber, BTnumber, BTnumber);
  }

  checkButton();
  if (button_pressed == 1) { //this is a reading light mode
    alwaysOn();
  }

  if (button_pressed == 2) {
    sweep(100);
  }

  if (button_pressed == 3) {
    leftToRight(100);
  }
  if (button_pressed == 4) {
    button_pressed = 0; //this will repeat the cycle by resetting the counter
    delay (500);
  }
}
